require Exporter;

@ISA=qw(Exporter);
@EXPORT=qw(ReadChFile ShowChSelectMenu);

my $Is_Bad_Pass = 0;

=item ReadChFile

Function ReadChFile load characters data from file and return array of
hashes. If recieving parameter, it will translated as filename, overwise
filename getted from config 'CharDataFile' parameter, overwise
from "./settings/char.dat" file.

=cut

sub ReadChFile
{
  my @Chars;
  my %ch_hash;
  my $first = 1;

  my $file = shift || $Conf{CharDataFile} || "./settings/char.dat";
  if (open F, "<$file") {
    while (<F>) {
      chomp;
      my $line = $_;
      if (( $line =~ m/^\s*$/ ) || ( $line =~ m/^[;#].*$/ )) {
        break;
      } else {
        if ( $line =~ m/^\[\s*char\s*\]/i ) {
          if (!$first) {
            push @Chars, { %ch_hash };
          }
          %ch_hash = {};
          $first = 0;
        } else {
          (my $nam, my $val) = split(/\s*=\s*/, $line);
          $ch_hash{$nam} = $val;
        }
      }
    }
    push @Chars, { %ch_hash };
    close F;
  } else {
    mc_print("   !", "b light red");
  }

  return @Chars;
}

=item ShowChSelectMenu

Showed list of all characters, loaded in internal list, recived as parameter.

=cut

sub ShowChSelectMenu
{
  my @ch_arr = @_;

  mc_print "0.     ";
  foreach $i (0 .. $#ch_arr) {
    $str = sprintf "%u. %-13s| %-20s:%5s | %s", $i+1, $ch_arr[$i]{name}, $ch_arr[$i]{host}, $ch_arr[$i]{port}, $ch_arr[$i]{description};
    mc_print $str;
  }
}

=item do_ChSelect

Produce all procedures, (linked) with choosing character selecting and
logon process, such as turning logging on/off.

=cut

sub do_ChSelect
{
  if ( $jmc->IsConnected ) {
    mc_print "     #zap!", "light red";
  } else {
    %Character = {};
    $jmc->Parse("#log");
    $Is_Bad_Pass = 0;
    $jmc->RegisterHandler("Input", "OnInput_ChSelect()");
    ShowChSelectMenu(@CharData);
  }
}

sub OnInput_ChSelect
{
  my $str = $jmc->Event;
  if (( $str =~ m/\d/) && ($str<=$#CharData+1)) {
    if ( $str == 0 ) {
      $jmc->RegisterHandler("Input", "");
    } else {
      %Character = %{$CharData[$str-1]};
      load_mud_conf($Character{mudfile});
      mc_print " $Character{name}  \"$Conf{MudName}\" ($Character{host}:$Character{port})", "light green";
      $jmc->RegisterHandler("Input", "");
      $jmc->RegisterHandler("Incoming", "OnIncoming_LogonTime");
      $jmc->connect($Character{host}, $Character{port});
    }
  } else {
    mc_print "  ";
  }
  $jmc->{Event} = undef;
}

sub OnIncoming_LogonTime
{
  use POSIX qw(strftime);
  my $str = $jmc->Event;

  for ($str)  {
    /$Conf{'LogonUserStr'}/  &&  do {
                      $jmc->send($Character{name}); last;
                     };
    /$Conf{'LogonPwdStr'}/  &&  do {
                      if ((!$Is_Bad_Pass) && ($Character{password} ne "")) {
                        $jmc->send($Character{password}); last;
                      }
                      last;
                    };
    /$Conf{'LogonFailure'}/  &&  do {
                      $jmc->{Event} = undef;
                      mc_print "${clr_red}${str}", "b light red";
                      $Is_Bad_Pass = 1;
                      last;
                    };
    /$Conf{'LogonSucces'}/  &&  do {
                      ($m,$y) = (localtime)[4,5]; $m++; $y += 1900;
                      $now = sprintf("%02u-%02u", $m, $y);
                      if ($m-1) {$m--; $y} else {$m = 12; $y--};
                      $last = sprintf ("%02u-%02u", $m, $y);
                      mkdir "logs", 0666;
                      mkdir "logs/$Conf{MudName}", 0666;
                      $jmc->Parse("#log ./logs/$Conf{MudName}/$Character{name}_$now.log append");
                      if ( -e "./logs/$Conf{MudName}/$Character{name}_$last.log" && $Conf{AcrOldLogs}) {
                        mc_print(" -   .", "yellow");
                        `rar m -ep .\\logs\\$Conf{MudName}\\$Character{name}_$last.rar .\\logs\\$Character{name}_$last.log`;
                      }
#                      $jmc->Parse("#read $Character{settings}");
                      $jmc->RegisterHandler("Incoming", "OnIncoming_main");
                      last;
                    };
  }
}

sub do_Reconnect()
{
  $jmc->parse("#zap");
  $jmc->RegisterHandler("Incoming", "OnIncoming_LogonTime");
  $jmc->connect($Character{host}, $Character{port});
}

1;